/*****************************************************
Chip type               : ATmega8A
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>                                              //   
#include <delay.h>                                              //   

// I2C Bus functions
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=4
   .equ __scl_bit=3
#endasm
#include <i2c.h>

#include <ds1307.h>                                             //     
#include <alcd.h>                                               //                                               

/***************   ***************/
unsigned int adc_data;

eeprom signed int yarche;                                       //  
eeprom signed char korr,hour_v1,min_v1,sek_v1,hour_o1,min_o1,sek_o1,hour_v2,min_v2,sek_v2,hour_o2,min_o2,sek_o2,
hour_v3,min_v3,sek_v3,hour_o3,min_o3,sek_o3;
eeprom unsigned char r1,r2,r3,r4,r5,r6,k1;

//  
interrupt [ADC_INT] void adc_isr(void)
{
adc_data=ADCW;
}

/***************************************************************/
void main(void)
{
unsigned char hour,min,sek,date,month,year,day,x1=1,x2,x3,m1=0,m2=0,m3=0,m4=0,m5=0,voll;
unsigned int volt,volt2;  
unsigned long int volt1;

//  B
PORTB=0x01;DDRB=0x1E;

//  C
PORTC=0x00;DDRC=0x00;

//  D
PORTD=0x0F;DDRD=0x00;

// _0   
TCCR0=0x00;TCNT0=0x00;

// _1,   ,   62,500 kHz,  , OC1A
TCCR1A=0x81;TCCR1B=0x0C;TCNT1H=0x00;TCNT1L=0x00;ICR1H=0x00;
ICR1L=0x00;OCR1AH=0x00;OCR1AL=(yarche/100);OCR1BH=0x00;OCR1BL=0x00;

// _2, 
ASSR=0x00;TCCR2=0x00;TCNT2=0x00;OCR2=0x00;

//    INT, 
MCUCR=0x00;

//  _0 
TIMSK=0x00;


// USART 
UCSRB=0x00;

//   
ACSR=0x80;SFIOR=0x00;

//  .    125,000 kHz,  Internal 2.56V Voltage cap. on AREF
ADMUX=0xC5;     // 0x45
ADCSRA=0x8F;
SFIOR&=0xEF;
ADCSRA.6=1;

// SPI 
SPCR=0x00;

// TWI 
TWCR=0x00;

// I2C 
i2c_init();

//     DS1307
rtc_init(0,0,0);

//  
lcd_init(16);

//   
#asm("sei")

while (1)
      {
        //**********************************  ************************************
         if (x1==1) {
         lcd_gotoxy(0,0);
         lcd_putsf("ceao        . pǽoce   ");                                 
         delay_ms(3000);
         lcd_clear();
         lcd_gotoxy(0,0);
         lcd_putsf(" aop Aece       pe    ");
         delay_ms(3000);
         lcd_clear();
         x1=0;
         rtc_get_day(&day);                                      //  
         k1=(day-1);
         };
          
      //****************************   *********************************         
        if (PIND.2==0) {                                        //    "" 
        delay_ms(150);                                          //   
          if (PIND.2==0) {                                      //    ""
          m1++;                                                 //   1
            if (m1==8) {                                        //  m1  7
            m1=0; }; }; };                                      //    
        
        if (day==1) {                                           //   
          if (k1>=7) {                                          //  k1  6
          k1=0; }; };                                           //  
        
        rtc_get_time(&hour,&min,&sek);                          //  
        rtc_get_date(&date,&month,&year);                       //  
        rtc_get_day(&day);                                      //  
        
        if ((hour==23)&(min==59)&(sek==30)) {                   //  ,  23:59:30
          if (korr>0) {                                         //    0
            if (k1!=day) {                                      //  1   
            sek=sek+korr;                                       //   
            rtc_set_time(hour,min,sek);                         //    DS1307
            k1++; }; };                                         //   1 1
              
          if (korr<0) {                                         //    0 
            if (k1!=day) {                                      //  1   
            sek=sek+korr;                                       //   
            rtc_set_time(hour,min,sek);                         //    DS1307 
            k1++; }; };};                                       //   1 1                  
              
        if ((hour==hour_v1)&(min==min_v1)&(sek==sek_v1)&(r2==1)) { //  ,   
        PORTB.2=1; };                                           //    2  1             

        if ((hour==hour_o1)&(min==min_o1)&(sek==sek_o1)) {         //  ,   
        PORTB.2=0; };                                          //    2  0  
        
        if ((hour==hour_v2)&(min==min_v2)&(sek==sek_v2)&(r4==1)) { //  ,   
        PORTB.3=1; };                                           //    3  1             

        if ((hour==hour_o2)&(min==min_o2)&(sek==sek_o2)) {         //  ,   
        PORTB.3=0; };                                          //    3  0 
        
        if ((hour==hour_v3)&(min==min_v3)&(sek==sek_v3)&(r6==1)) { //  ,   
        PORTB.4=1; };                                           //    4  1             

        if ((hour==hour_o3)&(min==min_o3)&(sek==sek_o3)) {         //  ,   
        PORTB.4=0; };                                          //    4  0
        
        //****************************   ***********************************
        if (m1==0) {
          for (volt=0, x2=10; x2>0; x2--) {                     // 10  
          ADCSRA.6 = 1;                                         //    
          while (ADCSRA & 0x40);                                //   
          volt += adc_data;                                     //  
          };                                                    //  10 
          volt=(volt/10);                                       //    10   
          
          if (day==1) {
          lcd_gotoxy(0,0);
          lcd_putsf(""); };                                    // 
            
          if (day==2) {
          lcd_gotoxy(0,0);
          lcd_putsf("B"); };                                    // 
            
          if (day==3) {
          lcd_gotoxy(0,0);
          lcd_putsf("Cp"); }                                     // 
          
          if (day==4) {
          lcd_gotoxy(0,0);
          lcd_putsf(""); };                                    //    

          if (day==5) {
          lcd_gotoxy(0,0);
          lcd_putsf(""); };                                    // 
            
          if (day==6) {
          lcd_gotoxy(0,0);
          lcd_putsf("C"); };                                    // 

          if (day==7) {
          lcd_gotoxy(0,0);
          lcd_putsf("Bc"); };                                    // 
          
          //if (volt<=592) {                                    
          if (volt>=152) {                                      //   3   
          voll=0x9B; };// };  

          if (volt<152) {                                       //   2,8
            if (volt>=142) {
            voll=0x9C;
             }; };                          

          if (volt<142) {                                       //   2,6
            if (volt>=132) {
            voll=0x9D;
            }; };               

          if (volt<132) {                                       //   2,4
            if (volt>=122) {
            voll=0x9E;
            }; };                          

          if (volt<122) {
          voll=0x9F;                                            //   2,2
          };                              
          
          lcd_gotoxy(12,0);
          lcd_putchar(voll);
          
          if (r2==1) {
          lcd_gotoxy(13,0);
          lcd_putsf(" P1"); }                                   //  1,   
          else {
           lcd_gotoxy(13,0);                                                  
           lcd_putsf("   "); };                                 //   ,    
           
          if (r4==1) {
          lcd_gotoxy(11,1);
          lcd_putsf("P2"); }                                    //  2,   
          else {
           lcd_gotoxy(11,1);                                                  
           lcd_putsf("  "); };                                  //   ,   
           
          if (r6==1) {
          lcd_gotoxy(14,1);
          lcd_putsf("P3"); }                                    //  3,   
          else {
           lcd_gotoxy(14,1);                                                  
           lcd_putsf("  "); };                                  //   ,   

        lcd_gotoxy(2,0);                                        //  , 
        lcd_putsf("/");
        lcd_putchar(date/10+0x30);
        lcd_putchar(date%10+0x30);
        lcd_putsf(".");
        lcd_putchar(month/10+0x30);
        lcd_putchar(month%10+0x30);
        lcd_putsf(".");
        lcd_putchar(year/10+0x30);
        lcd_putchar(year%10+0x30);
        lcd_putsf(" ");
        lcd_gotoxy(0,1);
        lcd_putchar(hour/10+0x30);
        lcd_putchar(hour%10+0x30);
        lcd_putsf(":");
        lcd_putchar(min/10+0x30);
        lcd_putchar(min%10+0x30);
        lcd_putsf(":");
        lcd_putchar(sek/10+0x30);
        lcd_putchar(sek%10+0x30);
        lcd_putsf("  ");

          if ((PIND.0==0)&(PIND.1==0)) {                        //   "+"  "-"
          delay_ms(500);                                        //   
            if ((PIND.0==0)&(PIND.1==0)) {                      //    
            delay_ms(500);                                      // ,     
              if ((PIND.0==0)&(PIND.1==0)) {                    //     
              k1=5;
              rtc_set_time(23,59,59);                           //  
              rtc_set_date(01,07,11);                           //  
              rtc_set_day(5); }; }; };                          //  
              
          if (PINB.0==0) {                                      //   "*"
          delay_ms(200);                                        // , 
            if (PINB.0==0) {
            delay_ms(300);
              if (PINB.0==0) {
              delay_ms(500);
                if (PINB.0==0) {
                delay_ms(700); 
                  if (PINB.0==0) {
                  delay_ms(900);
                    if (PINB.0==0) {
                    delay_ms(500);
                      if (PINB.0==0) {
                      delay_ms(300);
                        if (PINB.0==0) {                        //   
                        hour=0;
                        min=0;
                        sek=0;
                        date=0;
                        month=0;
                        year=0;
                        day=0; };};};};};};};}; 
        };
        
       /***********************   ***************************/
        if(m1==1) {                                             //   m1=1 
          if (PIND.0==0) {                                      //    "+"
          delay_ms(150);                                        //   
            if (PIND.0==0) {                                    //     "+"
            yarche += 255;                                      //   
              if (yarche >= 25755) {                            //   
              yarche = 0; }; };                                 //   0
              OCR1AL = (yarche/100); };                         //    OCR1AL,  

          if (PIND.1==0) {                                      //    "-"
          delay_ms(150);                                        //   
            if (PIND.1==0) {                                    //     "-"
            yarche -= 255;                                      //  
              if (yarche < 0) {                                 //   
              yarche = 25500; }; };                             //    
              OCR1AL = (yarche/100); };                         //    OCR1AL,  

        lcd_gotoxy(0,0);                                        //  " . 0 - 100%"
        lcd_putsf("poc oce.");
        lcd_gotoxy(0,1);
        lcd_puts("       ");
        lcd_putchar(((yarche/255)/100)+0x30);
        lcd_putchar((((yarche/255)%100)/10)+0x30); 
        lcd_putchar(((yarche/255)%10)+0x30);
        lcd_putsf("%     "); }; 
        
        /******************     ********************/
        if(m1==2) {                                             //   m1=2  
        m2=0;                                                   //  m2
        m3=0;                                                   //  m3
          if (PIND.0==0) {                                      //    "+"
          delay_ms(150);                                        //   
            if (PIND.0==0) {                                    //     "+"
            korr++;                                             //   1
              if (korr==30) {                                   //   29
              korr = 0; };};};                                  //   0 
             
          if (PIND.1==0) {                                      //    "-"
          delay_ms(150);                                        //   
            if (PIND.1==0) {                                    //     "-"
            korr--;                                             //   1
              if (korr==(-30)) {                                //   29
              korr = 0; };};};                                  //   0
          
        lcd_gotoxy(0,0);                                        //  ".  "  
        lcd_putsf("Koppe.  cy");
           
        if (korr>0) {                                           //   korr  0,  +
        lcd_gotoxy(0,1);
        lcd_putsf("+");
        lcd_putchar((korr/10)+0x30);
        lcd_putchar((korr%10)+0x30);
        lcd_putsf(" cey      "); };

        if (korr==0) {                                          //   korr  0,  
        lcd_gotoxy(0,1);
        lcd_putsf(" ");
        lcd_putchar((korr/10)+0x30);
        lcd_putchar((korr%10)+0x30);
        lcd_putsf(" cey      "); };

        if (korr<0) {                                           //   korr  0,  -
        lcd_gotoxy(0,1);
        lcd_putsf("-");
        lcd_putchar(((korr/10)-0x30)*-1);
        lcd_putchar(((korr%10)-0x30)*-1);
        lcd_putsf(" cey      "); }; };      
        
        /****************  ,  *******************/
        if(m1==3) {                                             //   m1=3
        m4=0;                                                   //  m4
        m5=0;                                                   //  m5
          if (PIND.3==0) {                                      //    "" 
          delay_ms(150);                                        //   
            if (PIND.3==0) {                                    //    ""
            m2++;                                               //   1
              if (m2==4) {                                      //  m2  3
              m2=0; }; }; };                                    //  
          
          /****************   ,  *******************/
          if (m2==0) {                                          //   m2=0
          lcd_gotoxy(0,0);
          lcd_putsf("caoa: pe");                         //  ": , , "
          lcd_gotoxy(0,1);
          lcd_putsf("co, aa.    "); };
          
          /********************   ***************************/
          if (m2==1) {                                          //   m2=1
            if (PINB.0==0) {                                    //    "*"
            delay_ms(250);                                      //   
              if (PINB.0==0) {                                  //     "*"
              m3++;                                             //    m3 1
                if (m3==3) {                                    //  m3  3
                m3=0; }; }; };                                  //    0

            if (m3==0) {                                        //   m3=0
            lcd_gotoxy(0,0);                                          
            lcd_putsf("cao ay ");                       //  " "
            lcd_gotoxy(0,1);
            lcd_putsf("co   ");                               //  ""
            lcd_putchar(date/10+0x30);
            lcd_putchar(date%10+0x30);
            lcd_putsf(":");
            lcd_putsf("     ");

              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                date++;                                         //   1
                  if (date==32) {                               //     32
                  date=1; }; }; };                              //   1
                  
              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                date--;                                         //   1
                  if (date==0) {                                //    0
                  date=31; }; }; }; };                          //   31 
                  
            if (m3==1) {                                        //   m3=1
            lcd_gotoxy(0,0);                                          
            lcd_putsf("cao ay");                        //  " "
            lcd_gotoxy(0,1);
            lcd_putsf("ec      ");                            //  ""
            lcd_putchar(month/10+0x30);
            lcd_putchar(month%10+0x30);
            lcd_putsf(":");
             
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                month++;                                        //   1
                  if (month==13) {                              //     12
                  month=1; }; }; };                             //   1
                        
              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                month--;                                        //   1
                  if (month==0) {                               //    0
                  month=12; }; }; }; };                         //   12
                   
            if (m3==2) {                                        //   m3=2
            lcd_gotoxy(0,0);                                          
            lcd_putsf("cao ay");                       //  " "
            lcd_gotoxy(0,1);                                          
            lcd_putsf("o          :");                        //  ""
            lcd_putchar(year/10+0x30);
            lcd_putchar(year%10+0x30);  
              
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                year++;                                         //   1
                  if (year==100) {                              //     99
                  year=10; }; }; };                             //   10
                    
              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                year--;                                         //   1
                  if (year==9) {                                //     10
                  year=99; }; }; }; };                          //   99 
          rtc_set_date(date,month,year); };                     //   

          /*******************    **********************/
          if(m2==2) {                                           //   m2=2
            if (PIND.0==0) {                                    //    "+"
            delay_ms(150);                                      //    
              if (PIND.0==0) {                                  //     "+"
              day++;                                            //   1
              k1=(day-1);                                       //  k1   
                if (day==8) {                                   //     7
                day=1; }; }; };                                 //   1

            if (PIND.1==0) {                                    //    "-"
            delay_ms(150);                                      //    
              if (PIND.1==0) {                                  //     "-"
              day--;                                            //   1
              k1=(day-1);                                       //  k1                                              
                if (day==0) {                                   //     1
                day=7; }; }; };                                 //   7 
                
           lcd_gotoxy(0,0);
           lcd_putsf(" caoa   ");                       //  " " 
             if (day==1) {
             lcd_gotoxy(0,1);
             lcd_putsf("  oeeĽ   ");};                   // 
              
             if (day==2) {
             lcd_gotoxy(0,1);
             lcd_putsf("    Bop     "); };                   // 
            
             if (day==3) {
             lcd_gotoxy(0,1);
             lcd_putsf("     Cpea      "); };                   // 

             if (day==4) {
             lcd_gotoxy(0,1);
             lcd_putsf("    eep     "); };                   //   

             if (day==5) {
             lcd_gotoxy(0,1);
             lcd_putsf("    ǿa     ");};                   // 

             if (day==6) {
             lcd_gotoxy(0,1);
             lcd_putsf("    Cyoa     ");};                   // 

             if (day==7) {
             lcd_gotoxy(0,1);
             lcd_putsf("  Bocpecee   ");};                    //  
                 
          rtc_set_day(day);                                     //    (1-, 2-, 3-, 4-  ..)
          };
          
          /*********************   ***********************/
          if(m2==3) {                                           //   m2=3
            if (PINB.0==0) {                                    //    "*"
            delay_ms(250);                                      //   
              if (PINB.0==0) {                                  //     "*"
              m3++;                                             //   m3  1
                if (m3==3) {                                    //  m3  3
                m3=0; }; }; };                                  //    0
                
            if (m3==0) {                                        //   m3=0
            lcd_gotoxy(0,0);                                          
            lcd_putsf("cao pe");                       //  " "
            lcd_gotoxy(0,1);
            lcd_putsf("ac    ");                               //  ""
            lcd_putchar(hour/10+0x30);
            lcd_putchar(hour%10+0x30);
            lcd_putsf(":");
            lcd_putsf("     ");
                
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour++;                                         //   1
                  if (hour==24) {                               //     23
                  hour=0; }; }; };                              //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour--;                                         //   1
                  if (hour==255) {                              //     0
                  hour=23; }; }; }; };                          //   23 

            if (m3==1) {                                        //   m3=1
            lcd_gotoxy(0,0);                                          
            lcd_putsf("cao pe");                       //  " "
            lcd_gotoxy(0,1);
            lcd_putsf("y     ");                            //  ""
            lcd_putchar(min/10+0x30);
            lcd_putchar(min%10+0x30);
            lcd_putsf(":  ");

              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min++;                                          //   1
                  if (min==60) {                                //     59
                  min=0; }; }; };                               //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min--;                                          //   1
                  if (min==255) {                               //     0
                  min=59; }; }; }; };                           //   59
                
            if (m3==2) {                                        //   m3=2
            lcd_gotoxy(0,0);                                          
            lcd_putsf("cao pe");                       //  " "
            lcd_gotoxy(0,1);                                          
            lcd_putsf("cey      :");                         //  ""
            lcd_putchar(sek/10+0x30);
            lcd_putchar(sek%10+0x30); 

              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek++;                                          //   1
                  if (sek==60) {                                //     59
                  sek=0; }; }; };                               //   0
                   
              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek--;                                          //   1
                  if (sek==255) {                               //     0
                  sek=59; }; }; }; };                           //   59
          rtc_set_time(hour,min,sek);                           //   
          };
        };
        
        /**********************   1 ***************************/
        if(m1==4) {                                             //   m1=4
        m2=0;                                                   //  m2
        m3=0;                                                   //  m3
          if (PIND.3==0) {                                      //    "" 
          delay_ms(150);                                        //   
            if (PIND.3==0) {                                    //    ""
            m4++;                                               //   1
              if (m4==3) {                                      //  m4  2
              m4=0; }; }; };                                    //  
          
           if (PINB.0==0) {                                     //    "*" 
            delay_ms(150);                                      //   
              if (PINB.0==0) {                                  //    "*"
              m5++;                                             //   1
                if (m5==7) {                                    //  m5  6
                m5=0; }; }; };                                  //  
          
          /***************************  1 ******************************/     
          if (m4==0) {                                          //   m4=0
          lcd_gotoxy(0,0);                                          
          lcd_putsf("caoa pee 1");                         //  " "
          lcd_gotoxy(0,1);
          lcd_putsf("                ");
          };
          
          /**********************  .  1 ***********************/
          if (m4==1) {                                          //   m4=1 
          
          lcd_gotoxy(0,0);
          lcd_putsf("Py. yp. pee 1");                        //  ". .  1"
          
            if (PIND.0==0) {                                    //    "+"
            delay_ms(150);                                      //   
              if (PIND.0==0) {                                  //    "+"
              r1++;                                             //   r1  1
                if (r1>=2) {                                    //  r1  1
                r1=0; }; }; };                                  //    0
                
            if (r1==1) {                                        //  r1=1
            PORTB.2=1;                                          //   B.2  1
            lcd_gotoxy(14,1);
            lcd_putsf("PP"); };                                 //  1

             if (r1==0) {                                       //  r1=0 
             r2=0;
             PORTB.2=0;                                         //    B.2  0
             lcd_gotoxy(14,1);                                                  
             lcd_putsf("  "); };                                //   
          };
          
          /********************** . .   ***********************/
          if(m4==2) {                                           //   m4=2
            if (m5==0) { 
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //   
                if (PIND.0==0) {                                //    "+"
                r2++;                                           //   r2  1
                  if (r2>=2) {                                  //  r2  1
                  r2=0; }; }; };                                //    0
                  
              if (r2==1) {
              lcd_gotoxy(0,0);                                          
              lcd_putsf("Pee1  aoae");                    //  "1  "
              lcd_gotoxy(0,1);                                          
              lcd_putsf("Pee   eo "); }                  //  "   " 
              
               else {
               lcd_gotoxy(0,0);                                          
               lcd_putsf("Pee1  aoae");                   //  "1  "
               lcd_gotoxy(0,1);                                          
               lcd_putsf("Pee   úeo"); }; };             //  "   "
               
            if (m5==1) {                                        //   m5=1              
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour_v1++;                                      //   1
                  if (hour_v1>=24) {                            //     23
                  hour_v1=0; }; }; };                           //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour_v1--;                                      //   1
                  if (hour_v1<0) {                              //     0
                  hour_v1=23; }; }; };                          //   23 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee1");                      //  ".. 1"
            lcd_gotoxy(0,1);
            lcd_putsf("    "); 
            lcd_putchar(hour_v1/10+0x30);
            lcd_putchar(hour_v1%10+0x30);                                         
            lcd_putsf(":");
            lcd_putsf("         "); };
            
            if (m5==2) {                                        //   m5=2
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min_v1++;                                       //   1
                  if (min_v1>=60) {                             //     59
                  min_v1=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min_v1--;                                       //   1
                  if (min_v1<0) {                               //     0
                  min_v1=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee1");                      //  ".. 1" 
            lcd_gotoxy(0,1);
            lcd_putsf("      :"); 
            lcd_putchar(min_v1/10+0x30);
            lcd_putchar(min_v1%10+0x30);                                         
            lcd_putsf("       "); };
            
            if (m5==3) {                                        //   m5=3
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek_v1++;                                       //   1
                  if (sek_v1>=60) {                             //     59
                  sek_v1=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek_v1--;                                       //   1
                  if (sek_v1<0) {                               //     0
                  sek_v1=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee1");                      //  ".. 1" 
            lcd_gotoxy(0,1);
            lcd_putsf("        :"); 
            lcd_putchar(sek_v1/10+0x30);
            lcd_putchar(sek_v1%10+0x30);                                         
            lcd_putsf("     "); };
            
            if (m5==4) {                                        //   m5=4
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour_o1++;                                      //   1
                  if (hour_o1>=24) {                            //     23
                  hour_o1=0; }; }; };                           //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour_o1--;                                      //   1
                  if (hour_o1<0) {                              //     0
                  hour_o1=23; }; }; };                          //   23 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee1");                      //  "..1" 
            lcd_gotoxy(0,1);
            lcd_putsf("    "); 
            lcd_putchar(hour_o1/10+0x30);
            lcd_putchar(hour_o1%10+0x30);                                         
            lcd_putsf(":");
            lcd_putsf("         "); };
            
            if (m5==5) {                                        //   m5=5
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min_o1++;                                       //   1
                  if (min_o1>=60) {                             //     59
                  min_o1=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min_o1--;                                       //   1
                  if (min_o1<0) {                               //     0
                  min_o1=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee1");                       //  "..1" 
            lcd_gotoxy(0,1);
            lcd_putsf("      :"); 
            lcd_putchar(min_o1/10+0x30);
            lcd_putchar(min_o1%10+0x30);                                         
            lcd_putsf("       "); };
            
            if (m5==6) {                                        //   m5=6
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek_o1++;                                       //   1
                  if (sek_o1>=60) {                             //     59
                  sek_o1=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek_o1--;                                       //   1
                  if (sek_o1<0) {                               //     0
                  sek_o1=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee1");                       //  "..1"  
            lcd_gotoxy(0,1);
            lcd_putsf("        :"); 
            lcd_putchar(sek_o1/10+0x30);
            lcd_putchar(sek_o1%10+0x30);                                         
            lcd_putsf("     "); };
          };
        };  //  "  1" 
        
        /**********************   2 ***************************/
        if(m1==5) {                                             //   m1=5
        m4=0;                                                   //  m4
        m5=0;                                                   //  m5
          if (PIND.3==0) {                                      //    "" 
          delay_ms(150);                                        //   
            if (PIND.3==0) {                                    //    ""
            m2++;                                               //   1
              if (m2>=3) {                                      //  m2  2
              m2=0; }; }; };                                    //  
          
           if (PINB.0==0) {                                     //    "*" 
            delay_ms(150);                                      //   
              if (PINB.0==0) {                                  //    "*"
              m3++;                                             //   1
                if (m3>=7) {                                    //  m3  6
                m3=0; }; }; };                                  //  
          
          /***************************  2 ******************************/     
          if (m2==0) {                                          //   m2=0
          lcd_gotoxy(0,0);                                          
          lcd_putsf("caoa pee 2");                        //  "  2"
          lcd_gotoxy(0,1);
          lcd_putsf("                ");
          };
          
          /**********************  .  2 ***********************/
          if (m2==1) {                                          //   m2=1 
           
          lcd_gotoxy(0,0);
          lcd_putsf("Py. yp. pee 2");                        //  ". .  2"
           
            if (PIND.0==0) {                                    //    "+"
            delay_ms(150);                                      //   
              if (PIND.0==0) {                                  //    "+"
              r3++;                                             //   r3  1
                if (r3>=2) {                                    //  r3  1
                r3=0; }; }; };                                  //    0
                
            if (r3==1) {                                        //  r3=1
            PORTB.3=1;                                          //   B.3  1
            lcd_gotoxy(14,1);
            lcd_putsf("PP"); };                                 //  P

             if (r3==0) {                                       //  r3=0 
             r4=0;
             PORTB.3=0;                                         //    B.3  0
             lcd_gotoxy(14,1);                                                  
             lcd_putsf("  "); };                                //  
          };
          
          /********************** . .   ***********************/
          if(m2==2) {                                           //   m2=2
            if (m3==0) { 
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //   
                if (PIND.0==0) {                                //    "+"
                r4++;                                           //   r4  1
                  if (r4>=2) {                                  //  r4  1
                  r4=0; }; }; };                                //    0
                  
              if (r4==1) {
              lcd_gotoxy(0,0);                                          
              lcd_putsf("Pee2  aoae");                    //  "2  "
              lcd_gotoxy(0,1);                                          
              lcd_putsf("Pee   eo "); }                  //  "   " 
              
               else {
               lcd_gotoxy(0,0);                                          
               lcd_putsf("Pee2  aoae");                   //  "2  "
               lcd_gotoxy(0,1);                                          
               lcd_putsf("Pee   úeo"); }; };             //  "   "
               
            if (m3==1) {                                        //   m3=1              
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour_v2++;                                      //   1
                  if (hour_v2>=24) {                            //     23
                  hour_v2=0; }; }; };                           //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour_v2--;                                      //   1
                  if (hour_v2<0) {                              //     0
                  hour_v2=23; }; }; };                          //   23 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee2");                      //  ".. 2"
            lcd_gotoxy(0,1);
            lcd_putsf("    "); 
            lcd_putchar(hour_v2/10+0x30);
            lcd_putchar(hour_v2%10+0x30);                                         
            lcd_putsf(":");
            lcd_putsf("         "); };
            
            if (m3==2) {                                        //   m3=2
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min_v2++;                                       //   1
                  if (min_v2>=60) {                             //     59
                  min_v2=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min_v2--;                                       //   1
                  if (min_v2<0) {                               //     0
                  min_v2=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee2");                      //  ".. 2" 
            lcd_gotoxy(0,1);
            lcd_putsf("      :"); 
            lcd_putchar(min_v2/10+0x30);
            lcd_putchar(min_v2%10+0x30);                                         
            lcd_putsf("       "); };
            
            if (m3==3) {                                        //   m3=3
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek_v2++;                                       //   1
                  if (sek_v2>=60) {                             //     59
                  sek_v2=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek_v2--;                                       //   1
                  if (sek_v2<0) {                               //     0
                  sek_v2=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee2");                      //  ".. 2" 
            lcd_gotoxy(0,1);
            lcd_putsf("        :"); 
            lcd_putchar(sek_v2/10+0x30);
            lcd_putchar(sek_v2%10+0x30);                                         
            lcd_putsf("     "); };
            
            if (m3==4) {                                        //   m3=4
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour_o2++;                                      //   1
                  if (hour_o2>=24) {                            //     23
                  hour_o2=0; }; }; };                           //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour_o2--;                                      //   1
                  if (hour_o2<0) {                              //     0
                  hour_o2=23; }; }; };                          //   23 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee2");                      //  "..2" 
            lcd_gotoxy(0,1);
            lcd_putsf("    "); 
            lcd_putchar(hour_o2/10+0x30);
            lcd_putchar(hour_o2%10+0x30);                                         
            lcd_putsf(":");
            lcd_putsf("         "); };
            
            if (m3==5) {                                        //   m3=5
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min_o2++;                                       //   1
                  if (min_o2>=60) {                             //     59
                  min_o2=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min_o2--;                                       //   1
                  if (min_o2<0) {                               //     0
                  min_o2=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee2");                       //  "..2" 
            lcd_gotoxy(0,1);
            lcd_putsf("      :"); 
            lcd_putchar(min_o2/10+0x30);
            lcd_putchar(min_o2%10+0x30);                                         
            lcd_putsf("       "); };
            
            if (m3==6) {                                        //   m3=6
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek_o2++;                                       //   1
                  if (sek_o2>=60) {                             //     59
                  sek_o2=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek_o2--;                                       //   1
                  if (sek_o2<0) {                               //     0
                  sek_o2=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee2");                       //  "..2"  
            lcd_gotoxy(0,1);
            lcd_putsf("        :"); 
            lcd_putchar(sek_o2/10+0x30);
            lcd_putchar(sek_o2%10+0x30);                                         
            lcd_putsf("     "); };
          };
        };  //  "  2"  
        
        /**********************   3 ***************************/
        if(m1==6) {                                             //   m1=4
        m2=0;                                                   //  m2
        m3=0;                                                   //  m3
          if (PIND.3==0) {                                      //    "" 
          delay_ms(150);                                        //   
            if (PIND.3==0) {                                    //    ""
            m4++;                                               //   1
              if (m4>=3) {                                      //  m4  2
              m4=0; }; }; };                                    //  
          
           if (PINB.0==0) {                                     //    "*" 
            delay_ms(150);                                      //   
              if (PINB.0==0) {                                  //    "*"
              m5++;                                             //   1
                if (m5>=7) {                                    //  m5  6
                m5=0; }; }; };                                  //  
          
          /***************************  3 ******************************/     
          if (m4==0) {                                          //   m4=0
          lcd_gotoxy(0,0);                                          
          lcd_putsf("caoa pee 3");                         //  "  3"
          lcd_gotoxy(0,1);
          lcd_putsf("                ");
          };
          
          /**********************  .  3 ***********************/
          if (m4==1) {                                          //   m4=1 
          
          lcd_gotoxy(0,0);
          lcd_putsf("Py. yp. pee 3");                        //  ". .  3"
          
            if (PIND.0==0) {                                    //    "+"
            delay_ms(150);                                      //   
              if (PIND.0==0) {                                  //    "+"
              r5++;                                             //   r5  1
                if (r5>=2) {                                    //  r5  1
                r5=0; }; }; };                                  //    0
                
            if (r5==1) {                                        //  r5=1
            PORTB.4=1;                                          //   B.4  1
            lcd_gotoxy(14,1);
            lcd_putsf("PP"); };                                 //  P

             if (r5==0) {                                       //  r5=0 
             r6=0;
             PORTB.4=0;                                         //    B.4  0
             lcd_gotoxy(14,1);                                                  
             lcd_putsf("  "); };                                //   
          };
          
          /********************** . .   ***********************/
          if(m4==2) {                                           //   m4=2
            if (m5==0) { 
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //   
                if (PIND.0==0) {                                //    "+"
                r6++;                                           //   r6  1
                  if (r6>=2) {                                  //  r6  1
                  r6=0; }; }; };                                //    0
                  
              if (r6==1) {
              lcd_gotoxy(0,0);                                          
              lcd_putsf("Pee3  aoae");                    //  "3  "
              lcd_gotoxy(0,1);                                          
              lcd_putsf("Pee   eo "); }                  //  "   " 
              
               else {
               lcd_gotoxy(0,0);                                          
               lcd_putsf("Pee3  aoae");                   //  "3  "
               lcd_gotoxy(0,1);                                          
               lcd_putsf("Pee   úeo"); }; };             //  "   "
               
            if (m5==1) {                                        //   m5=1              
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour_v3++;                                      //   1
                  if (hour_v3>=24) {                            //     23
                  hour_v3=0; }; }; };                           //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour_v3--;                                      //   1
                  if (hour_v3<0) {                              //     0
                  hour_v3=23; }; }; };                          //   23 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee3");                      //  ".. 3"
            lcd_gotoxy(0,1);
            lcd_putsf("    "); 
            lcd_putchar(hour_v3/10+0x30);
            lcd_putchar(hour_v3%10+0x30);                                         
            lcd_putsf(":");
            lcd_putsf("         "); };
            
            if (m5==2) {                                        //   m5=2
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min_v3++;                                       //   1
                  if (min_v3>=60) {                             //     59
                  min_v3=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min_v3--;                                       //   1
                  if (min_v3<0) {                               //     0
                  min_v3=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee3");                      //  ".. 3" 
            lcd_gotoxy(0,1);
            lcd_putsf("      :"); 
            lcd_putchar(min_v3/10+0x30);
            lcd_putchar(min_v3%10+0x30);                                         
            lcd_putsf("       "); };
            
            if (m5==3) {                                        //   m5=3
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek_v3++;                                       //   1
                  if (sek_v3>=60) {                             //     59
                  sek_v3=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek_v3--;                                       //   1
                  if (sek_v3<0) {                               //     0
                  sek_v3=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.B. Pee3");                      //  ".. 3" 
            lcd_gotoxy(0,1);
            lcd_putsf("        :"); 
            lcd_putchar(sek_v3/10+0x30);
            lcd_putchar(sek_v3%10+0x30);                                         
            lcd_putsf("     "); };
            
            if (m5==4) {                                        //   m5=4
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                hour_o3++;                                      //   1
                  if (hour_o3>=24) {                            //     23
                  hour_o3=0; }; }; };                           //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                hour_o3--;                                      //   1
                  if (hour_o3<0) {                              //     0
                  hour_o3=23; }; }; };                          //   23 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee3");                      //  "..3" 
            lcd_gotoxy(0,1);
            lcd_putsf("    "); 
            lcd_putchar(hour_o3/10+0x30);
            lcd_putchar(hour_o3%10+0x30);                                         
            lcd_putsf(":");
            lcd_putsf("         "); };
            
            if (m5==5) {                                        //   m5=5
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                min_o3++;                                       //   1
                  if (min_o3>=60) {                             //     59
                  min_o3=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                min_o3--;                                       //   1
                  if (min_o3<0) {                               //     0
                  min_o3=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee3");                       //  "..3" 
            lcd_gotoxy(0,1);
            lcd_putsf("      :"); 
            lcd_putchar(min_o3/10+0x30);
            lcd_putchar(min_o3%10+0x30);                                         
            lcd_putsf("       "); };
            
            if (m5==6) {                                        //   m5=6
              if (PIND.0==0) {                                  //    "+"
              delay_ms(150);                                    //    
                if (PIND.0==0) {                                //     "+"
                sek_o3++;                                       //   1
                  if (sek_o3>=60) {                             //     59
                  sek_o3=0; }; }; };                            //   0

              if (PIND.1==0) {                                  //    "-"
              delay_ms(150);                                    //    
                if (PIND.1==0) {                                //     "-"
                sek_o3--;                                       //   1
                  if (sek_o3<0) {                               //     0
                  sek_o3=59; }; }; };                           //   59 

            lcd_gotoxy(0,0);                                          
            lcd_putsf("Hacp.Bú.Pee3");                       //  "..3"  
            lcd_gotoxy(0,1);
            lcd_putsf("        :"); 
            lcd_putchar(sek_o3/10+0x30);
            lcd_putchar(sek_o3%10+0x30);                                         
            lcd_putsf("     "); };
          };
        };  //  "  3"
        
        /**************************   ************************/ 
        if (m1==7) { 
          for (volt2=0, x3=10; x3>0; x3--) {                    // 10   100 
            for (volt=0, x2=100; x2>0; x2--) {                  // 100  
            ADCSRA.6 = 1;                                       //    
            while (ADCSRA & 0x40);                              //   
            volt += adc_data;                                   //  
            };
            volt1=(volt/100);
            volt1=((volt1*1000)/501);
            volt2 += volt1;
          };
          volt2=(volt2/10);
          
        lcd_gotoxy(0,0);                                          
        lcd_putsf("HapǶee a. ");                           //  " ."
        lcd_gotoxy(0,1);
        lcd_putsf("     ");
        lcd_putchar((volt2/100)+0x30);
        lcd_putsf(".");
        lcd_putchar(((volt2%100)/10)+0x30);
        lcd_putchar((volt2%10)+0x30);
        lcd_putsf("B");
        lcd_putsf("      ");
        };
         
      }; //  while(1)
} //  
